const UserModel = require('../models/UserModel') // مسیر درست به مدل کاربر
const jwt = require('jsonwebtoken')

module.exports = async (req, res, next) => {
  console.log(2);
  try {
    if (!('authorization' in req.headers)) {
      return res.status(401).send({
        status: 'error',
        code: 401,
        message: 'You are not authorized!'
      })
    }

    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)

    if (!decodedToken) {
      return res.status(401).send({
        status: 'error',
        code: 401,
        message: 'Your token is not valid!'
      })
    }

    const user = await UserModel.findById(decodedToken.id)
    if (user.block_status === true) {
      return res.status(403).send({
        status: 'error',
        code: 403,
        message: 'حساب کاربری شما مسدود شده است، برای اطلاعات بیشتر با پشتیبانی تماس بگیرید!',
        type: 'block'
      })
    }

    req.user = user // کاربر را به درخواست اضافه کنید تا در سایر middleware ها و کنترلرها استفاده شود.
    next()
  } catch (error) {
    console.error('Error in blockCheck middleware:', error)
    res.status(500).send({
      status: 'error',
      code: 500,
      message: 'Server error'
    })
  }
}
